Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.cpp	(revision 12878)
@@ -28,5 +28,5 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nKMLOverlayx Module -- %s",ctime(&time0));
+	_pprintString_("\nKMLOverlayx Module -- " << ctime(&time0));
 
 /*  construct kml file  */
@@ -82,5 +82,5 @@
 /*  write kml file  */
 
-	_printf_(true,"Writing kml document to file.\n");
+	_pprintLine_("Writing kml document to file.");
 	fprintf(fid,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
 	kfile->Write(fid,indent);
Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLOverlayx/KMLOverlayx.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 12878)
@@ -38,5 +38,5 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nKml2Expx Module -- %s",ctime(&time0));
+	_pprintString_("\nKml2Expx Module -- " << ctime(&time0));
 
 /*  read kml file  */
@@ -44,10 +44,10 @@
 	fidi=fopen(filkml,"r");
 	if (!(kobj=KMLFileReadx(fidi)))
-		_error_("Error reading kml file.");
+		_error2_("Error reading kml file.");
 	fclose(fidi);
 
 /*  open exp file  */
 
-	_printf_(true,"Writing exp profiles to file.\n");
+	_pprintLine_("Writing exp profiles to file.");
 	fido=fopen(filexp,"w");
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Kml2Expx/Kml2Expx.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp	(revision 12878)
@@ -7,13 +7,10 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Observations.h"
 #include "../modules.h"
-
 #ifdef _HAVE_GSL_
 #include <gsl/gsl_linalg.h>
 #endif
-
-#include "../../objects/Kriging/GaussianVariogram.h"
 /*FUNCTION Krigingx{{{*/
 int Krigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){
@@ -24,5 +21,6 @@
 
 	/*Intermediaries*/
-	double        range;
+	int           mindata,maxdata;
+	double        radius;
 	char         *output       = NULL;
 	Variogram    *variogram    = NULL;
@@ -38,5 +36,7 @@
 	/*Get Variogram from Options*/
 	ProcessVariogram(&variogram,options);
-	options->Get(&range,"searchrange",0.);
+	options->Get(&radius,"searchradius",0.);
+	options->Get(&mindata,"mindata",1);
+	options->Get(&maxdata,"maxdata",50);
 
 	/*Process observation dataset*/
@@ -44,6 +44,6 @@
 
 	/*Allocate output*/
-	predictions =(double*)xcalloc(n_interp,sizeof(double));
-	error       =(double*)xcalloc(n_interp,sizeof(double));
+	predictions =xNewZeroInit<double>(n_interp);
+	error       =xNewZeroInit<double>(n_interp);
 
 	/*Get output*/
@@ -56,24 +56,87 @@
 		observations->Variomap(predictions,x_interp,n_interp);
 	}
-	else if(strcmp(output,"prediction")==0){
-
+	else if(strcmp(output,"delaunay")==0){
+		int nobs,nel;
+		double *x     = NULL;
+		double *y     = NULL;
+		double *data  = NULL;
+		int    *index = NULL;
+
+		observations->ObservationList(&x,&y,&data,&nobs);
+
+		_printLine_("Generation Delaunay Triangulation");
+		BamgTriangulatex(&index,&nel,x,y,nobs);
+
+		_printLine_("Interpolating");
+		xDelete<double>(predictions);
+		InterpFromMeshToMesh2dx(&predictions,index,x,y,nobs,nel,data,nobs,1,x_interp,y_interp,n_interp,options);
+		xDelete<double>(x);
+		xDelete<double>(y);
+		xDelete<double>(data);
+		xDelete<int>(index);
+	}
+	else if(strcmp(output,"nearestneighbor")==0){
 		/*initialize thread parameters: */
 		gate.n_interp     = n_interp;
 		gate.x_interp     = x_interp;
 		gate.y_interp     = y_interp;
-		gate.range        = range;
+		gate.radius       = radius;
+		gate.mindata      = mindata;
+		gate.maxdata      = maxdata;
 		gate.variogram    = variogram;
 		gate.observations = observations;
 		gate.predictions  = predictions;
 		gate.error        = error;
-		gate.percent      = (double*)xcalloc(num,sizeof(double));
+		gate.percent      = xNewZeroInit<double>(num);
+
+		/*launch the thread manager with Krigingxt as a core: */
+		LaunchThread(NearestNeighbort,(void*)&gate,num);
+		_printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		xDelete<double>(gate.percent);
+	}
+	else if(strcmp(output,"idw")==0){ //Inverse distance weighting
+		double power;
+		options->Get(&power,"power",2.);
+		/*initialize thread parameters: */
+		gate.n_interp     = n_interp;
+		gate.x_interp     = x_interp;
+		gate.y_interp     = y_interp;
+		gate.radius       = radius;
+		gate.mindata      = mindata;
+		gate.maxdata      = maxdata;
+		gate.variogram    = variogram;
+		gate.observations = observations;
+		gate.predictions  = predictions;
+		gate.error        = error;
+		gate.percent      = xNewZeroInit<double>(num);
+		gate.power        = power;
+
+		/*launch the thread manager with Krigingxt as a core: */
+		LaunchThread(idwt,(void*)&gate,num);
+		_printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		xDelete<double>(gate.percent);
+	}
+	else if(strcmp(output,"prediction")==0){
+
+		/*initialize thread parameters: */
+		gate.n_interp     = n_interp;
+		gate.x_interp     = x_interp;
+		gate.y_interp     = y_interp;
+		gate.radius       = radius;
+		gate.mindata      = mindata;
+		gate.maxdata      = maxdata;
+		gate.variogram    = variogram;
+		gate.observations = observations;
+		gate.predictions  = predictions;
+		gate.error        = error;
+		gate.percent      = xNewZeroInit<double>(num);
 
 		/*launch the thread manager with Krigingxt as a core: */
 		LaunchThread(Krigingxt,(void*)&gate,num);
-		printf("\r      interpolation progress:  100.00%%\n");
-		xfree((void**)&gate.percent);
+		_printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		xDelete<double>(gate.percent);
 	}
 	else{
-		_error_("output '%s' not supported yet",output);
+		_error2_("output '" << output << "' not supported yet");
 	}
 
@@ -81,5 +144,5 @@
 	delete variogram;
 	delete observations;
-	xfree((void**)&output);
+	xDelete<char>(output);
 	*ppredictions = predictions;
 	*perror       = error;
@@ -106,5 +169,7 @@
 	double       *x_interp     = gate->x_interp;
 	double       *y_interp     = gate->y_interp;
-	double        range        = gate->range;
+	double        radius       = gate->radius;
+	int           mindata      = gate->mindata;
+	int           maxdata      = gate->maxdata;
 	Variogram    *variogram    = gate->variogram;
 	Observations *observations = gate->observations;
@@ -114,15 +179,54 @@
 
 	/*Intermediaries*/
-	int           i,j,n_obs;
-	double        numerator,denominator,ratio,localpercent;
-	double       *x            = NULL;
-	double       *y            = NULL;
-	double       *obs          = NULL;
-	double       *Gamma        = NULL;
-	double       *GinvG0       = NULL;
-	double       *Ginv1        = NULL;
-	double       *GinvZ        = NULL;
-	double       *gamma0       = NULL;
-	double       *ones         = NULL;
+	double        localpercent;
+
+	/*partition loop across threads: */
+	PartitionRange(&i0,&i1,n_interp,num_threads,my_thread);
+	for(int idx=i0;idx<i1;idx++){
+
+		/*Print info*/
+		percent[my_thread]=double(idx-i0)/double(i1-i0)*100.;
+		localpercent=percent[0];
+		for(int i=1;i<num_threads;i++) localpercent=min(localpercent,percent[i]);
+		if(my_thread==0) _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<localpercent<<"%");
+
+		/*Kriging interpolation*/
+		observations->InterpolationKriging(&predictions[idx],&error[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,variogram);
+	}
+
+	return NULL;
+}/*}}}*/
+/*FUNCTION NearestNeighbort{{{*/
+void* NearestNeighbort(void* vpthread_handle){
+
+	/*gate variables :*/
+	KrigingxThreadStruct *gate        = NULL;
+	pthread_handle       *handle      = NULL;
+	int my_thread;
+	int num_threads;
+	int i0,i1;
+
+	/*recover handle and gate: */
+	handle      = (pthread_handle*)vpthread_handle;
+	gate        = (KrigingxThreadStruct*)handle->gate;
+	my_thread   = handle->id;
+	num_threads = handle->num;
+
+	/*recover parameters :*/
+	int           n_interp     = gate->n_interp;
+	double       *x_interp     = gate->x_interp;
+	double       *y_interp     = gate->y_interp;
+	double        radius       = gate->radius;
+	int           mindata      = gate->mindata;
+	int           maxdata      = gate->maxdata;
+	Variogram    *variogram    = gate->variogram;
+	Observations *observations = gate->observations;
+	double       *predictions  = gate->predictions;
+	double       *error        = gate->error;
+	double       *percent      = gate->percent;
+
+	/*Intermediaries*/
+	int           i;
+	double        localpercent;
 
 	/*partition loop across threads: */
@@ -134,54 +238,56 @@
 		localpercent=percent[0];
 		for(i=1;i<num_threads;i++) localpercent=min(localpercent,percent[i]);
-		printf("\r      interpolation progress: %5.2lf%%",localpercent);
-
-		/*Get list of observations for current point*/
-		observations->ObservationList(&x,&y,&obs,&n_obs,x_interp[idx],y_interp[idx],range);
-
-		/*Allocate intermediary matrix and vectors*/
-		Gamma  = (double*)xmalloc(n_obs*n_obs*sizeof(double));
-		gamma0 = (double*)xmalloc(n_obs*sizeof(double));
-		ones   = (double*)xmalloc(n_obs*sizeof(double));
-
-		/*First: Create semivariogram matrix for observations*/
-		for(i=0;i<n_obs;i++){
-			for(j=0;j<=i;j++){
-				Gamma[i*n_obs+j] = variogram->SemiVariogram(x[i]-x[j],y[i]-y[j]);
-				Gamma[j*n_obs+i] = Gamma[i*n_obs+j];
-			}
-		}
-		for(i=0;i<n_obs;i++) ones[i]=1;
-
-		/*Get semivariogram vector associated to this location*/
-		for(i=0;i<n_obs;i++) gamma0[i] = variogram->SemiVariogram(x[i]-x_interp[idx],y[i]-y_interp[idx]);
-
-		/*Solve the three linear systems*/
-		GslSolve(&GinvG0,Gamma,gamma0,n_obs); // Gamma^-1 gamma0
-		GslSolve(&Ginv1, Gamma,ones,n_obs);   // Gamma^-1 ones
-		GslSolve(&GinvZ, Gamma,obs,n_obs);    // Gamma^-1 Z
-
-		/*Prepare predictor*/
-		numerator=-1.; denominator=0.;
-		for(i=0;i<n_obs;i++) numerator  +=GinvG0[i];
-		for(i=0;i<n_obs;i++) denominator+=Ginv1[i];
-		ratio=numerator/denominator;
-
-		predictions[idx] = 0.;
-		error[idx]       = - numerator*numerator/denominator;
-		for(i=0;i<n_obs;i++) predictions[idx] += (gamma0[i]-ratio)*GinvZ[i];
-		for(i=0;i<n_obs;i++) error[idx] += gamma0[i]*GinvG0[i];
-
-		/*clean-up*/
-		xfree((void**)&x);
-		xfree((void**)&y);
-		xfree((void**)&obs);
-		xfree((void**)&Gamma);
-		xfree((void**)&gamma0);
-		xfree((void**)&ones);
-		xfree((void**)&GinvG0);
-		xfree((void**)&Ginv1);
-		xfree((void**)&GinvZ);
-	}
-
+		if(my_thread==0) _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<localpercent<<"%");
+
+		observations->InterpolationNearestNeighbor(&predictions[idx],x_interp[idx],y_interp[idx],radius);
+	}
+
+	return NULL;
+}/*}}}*/
+/*FUNCTION idwt{{{*/
+void* idwt(void* vpthread_handle){
+
+	/*gate variables :*/
+	KrigingxThreadStruct *gate        = NULL;
+	pthread_handle       *handle      = NULL;
+	int my_thread;
+	int num_threads;
+	int i0,i1;
+
+	/*recover handle and gate: */
+	handle      = (pthread_handle*)vpthread_handle;
+	gate        = (KrigingxThreadStruct*)handle->gate;
+	my_thread   = handle->id;
+	num_threads = handle->num;
+
+	/*recover parameters :*/
+	int           n_interp     = gate->n_interp;
+	double       *x_interp     = gate->x_interp;
+	double       *y_interp     = gate->y_interp;
+	double        radius       = gate->radius;
+	int           mindata      = gate->mindata;
+	int           maxdata      = gate->maxdata;
+	Variogram    *variogram    = gate->variogram;
+	Observations *observations = gate->observations;
+	double       *predictions  = gate->predictions;
+	double       *error        = gate->error;
+	double       *percent      = gate->percent;
+	double        power        = gate->power;
+
+	/*Intermediaries*/
+	double localpercent;
+
+	/*partition loop across threads: */
+	PartitionRange(&i0,&i1,n_interp,num_threads,my_thread);
+	for(int idx=i0;idx<i1;idx++){
+
+		/*Print info*/
+		percent[my_thread]=double(idx-i0)/double(i1-i0)*100.;
+		localpercent=percent[0];
+		for(int i=1;i<num_threads;i++) localpercent=min(localpercent,percent[i]);
+		if(my_thread==0) _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<localpercent<<"%");
+
+		observations->InterpolationIDW(&predictions[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,power);
+	}
 	return NULL;
 }/*}}}*/
@@ -199,50 +305,10 @@
 		else if(strcmp(model,"spherical")==0)   variogram = new SphericalVariogram(options);
 		else if(strcmp(model,"power")==0)       variogram = new PowerVariogram(options);
-		else _error_("variogram %s not supported yet (list of supported variogram: gaussian, exponential, spherical and power)",model);
+		else _error2_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
 	}
 	else variogram = new GaussianVariogram(options);
 
 	/*Assign output pointer*/
-	xfree((void**)&model);
+	xDelete<char>(model);
 	*pvariogram = variogram;
 }/*}}}*/
-void GslSolve(double** pX,double* A,double* B,int n){/*{{{*/
-#ifdef _HAVE_GSL_
-
-		/*GSL Matrices and vectors: */
-		int              s;
-		gsl_matrix_view  a;
-		gsl_vector_view  b;
-		gsl_vector      *x = NULL;
-		gsl_permutation *p = NULL;
-
-		/*A will be modified by LU decomposition. Use copy*/
-		double* Acopy = (double*)xmalloc(n*n*sizeof(double));
-		memcpy(Acopy,A,n*n*sizeof(double));
-
-		/*Initialize gsl matrices and vectors: */
-		a = gsl_matrix_view_array (Acopy,n,n);
-		b = gsl_vector_view_array (B,n);
-		x = gsl_vector_alloc (n);
-
-		/*Run LU and solve: */
-		p = gsl_permutation_alloc (n);
-		gsl_linalg_LU_decomp (&a.matrix, p, &s);
-		gsl_linalg_LU_solve (&a.matrix, p, &b.vector, x);
-
-		//printf ("x = \n");
-		//gsl_vector_fprintf (stdout, x, "%g");
-
-		/*Copy result*/
-		double* X = (double*)xmalloc(n*sizeof(double));
-		memcpy(X,gsl_vector_ptr(x,0),n*sizeof(double));
-
-		/*Clean up and assign output pointer*/
-		xfree((void**)&Acopy);
-		gsl_permutation_free(p);
-		gsl_vector_free(x);
-		*pX=X;
-#else
-		_error_("GSL support required");
-#endif
-	}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _KRIGINGX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../toolkits/toolkits.h"
 
@@ -13,6 +13,6 @@
 
 int  Krigingx(double** ppredictions,double **perror,double* x, double* y, double* observations, int n_obs,double* x_interp,double* y_interp,int n_interp,Options* options);
+int  pKrigingx(double** ppredictions,double **perror,double* x, double* y, double* observations, int n_obs,double* x_interp,double* y_interp,int n_interp,Options* options);
 void ProcessVariogram(Variogram **pvariogram,Options* options);
-void GslSolve(double** pX,double* A,double* B,int n);
 
 /*threading: */
@@ -21,5 +21,7 @@
 	double       *x_interp;
 	double       *y_interp;
-	double        range;
+	double        radius;
+	int           mindata;
+	int           maxdata;
 	Variogram    *variogram;
 	Observations *observations;
@@ -27,6 +29,9 @@
 	double       *error;
 	double       *percent;
+	double        power;//for idw
 }KrigingxThreadStruct;
 
 void* Krigingxt(void*);
+void* NearestNeighbort(void*);
+void* idwt(void*);
 #endif /* _KRIGINGX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/pKrigingx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/pKrigingx.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/pKrigingx.cpp	(revision 12878)
@@ -0,0 +1,135 @@
+/*!\file:  Kriging.cpp
+ * \brief  "c" core code for Kriging
+ */ 
+
+#include "./Krigingx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../classes/objects/objects.h"
+#include "../../Container/Container.h"
+#include "../../io/io.h"
+
+/*FUNCTION pKrigingx{{{*/
+int pKrigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){
+
+	extern int num_procs;
+	extern int my_rank;
+
+	/*output*/
+	double *predictions = NULL;
+	double *error       = NULL;
+
+	/*Intermediaries*/
+	int           mindata,maxdata;
+	double        radius;
+	char         *output       = NULL;
+	Variogram    *variogram    = NULL;
+	Observations *observations = NULL;
+
+	/*Get some Options*/
+	options->Get(&radius,"searchradius",0.);
+	options->Get(&mindata,"mindata",1);
+	options->Get(&maxdata,"maxdata",50);
+
+	/*Process observation dataset*/
+	observations=new Observations(obs_list,obs_x,obs_y,obs_length,options);
+
+	/*Allocate output*/
+	predictions =xNewZeroInit<double>(n_interp);
+	error       =xNewZeroInit<double>(n_interp);
+
+	/*Get output*/
+	options->Get(&output,"output","prediction");
+
+	if(strcmp(output,"quadtree")==0){
+		observations->QuadtreeColoring(predictions,x_interp,y_interp,n_interp);
+	}
+	else if(strcmp(output,"variomap")==0){
+		observations->Variomap(predictions,x_interp,n_interp);
+	}
+	else if(strcmp(output,"prediction")==0){
+
+		/*Process Variogram*/
+		ProcessVariogram(&variogram,options);
+
+		/*partition loop across threads: */
+		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
+			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			observations->InterpolationKriging(&predictions[idx],&error[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,variogram);
+		}
+		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+
+#ifdef _HAVE_MPI_
+		double *sumpredictions =xNew<double>(n_interp);
+		double *sumerror       =xNew<double>(n_interp);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		MPI_Allreduce(error,sumerror,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		xDelete<double>(error); error=sumerror;
+		xDelete<double>(predictions); predictions=sumpredictions;
+#endif
+	}
+	else if(strcmp(output,"nearestneighbor")==0){
+
+		/*partition loop across threads: */
+		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
+			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			observations->InterpolationNearestNeighbor(&predictions[idx],x_interp[idx],y_interp[idx],radius);
+		}
+		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+
+#ifdef _HAVE_MPI_
+		double *sumpredictions =xNew<double>(n_interp);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		xDelete<double>(predictions); predictions=sumpredictions;
+#endif
+	}
+	else if(strcmp(output,"idw")==0){
+		double power;
+		options->Get(&power,"power",2.);
+
+		/*partition loop across threads: */
+		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
+			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			observations->InterpolationIDW(&predictions[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,power);
+		}
+		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+
+#ifdef _HAVE_MPI_
+		double *sumpredictions =xNew<double>(n_interp);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		xDelete<double>(predictions); predictions=sumpredictions;
+#endif
+	}
+	else{
+		_error2_("output '" << output << "' not supported yet");
+	}
+
+	/*clean-up and Assign output pointer*/
+	delete variogram;
+	delete observations;
+	xDelete<char>(output);
+	*ppredictions = predictions;
+	*perror       = error;
+	return 1;
+}/*}}}*/
+void ProcessVariogram(Variogram **pvariogram,Options* options){/*{{{*/
+
+	/*Intermediaries*/
+	Variogram* variogram = NULL;
+	char      *model     = NULL;
+
+	if(options->GetOption("model")){
+		options->Get(&model,"model");
+		if     (strcmp(model,"gaussian")==0)    variogram = new GaussianVariogram(options);
+		else if(strcmp(model,"exponential")==0) variogram = new ExponentialVariogram(options);
+		else if(strcmp(model,"spherical")==0)   variogram = new SphericalVariogram(options);
+		else if(strcmp(model,"power")==0)       variogram = new PowerVariogram(options);
+		else _error2_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
+	}
+	else variogram = new GaussianVariogram(options);
+
+	/*Assign output pointer*/
+	xDelete<char>(model);
+	*pvariogram = variogram;
+}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Ll2xyx/Ll2xyx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Ll2xyx/Ll2xyx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Ll2xyx/Ll2xyx.cpp	(revision 12878)
@@ -52,5 +52,5 @@
 	double  T,rho,sl,tc,mc;
 
-	if((sgn!=1) && (sgn!=-1)) _error_("Sign should be either +1 or -1.\n");
+	if((sgn!=1) && (sgn!=-1)) _error2_("Sign should be either +1 or -1.\n");
 
 	delta = central_meridian;
@@ -116,12 +116,12 @@
 		*pdelta= 45;
 		*pslat = 70;
-		_printf_(flag,"Info: creating coordinates in polar stereographic (Std Latitude: 70N Meridian: 45).\n");
+		if(flag) _pprintLine_("Info: creating coordinates in polar stereographic (Std Latitude: 70N Meridian: 45).");
 	}
 	else if (sgn == -1) {
 		*pdelta= 0;
 		*pslat = 71;
-		_printf_(flag,"Info: creating coordinates in polar stereographic (Std Latitude: 71S Meridian: 0).\n");
+		if(flag) _pprintLine_("Info: creating coordinates in polar stereographic (Std Latitude: 71S Meridian: 0).");
 	}
-	else _error_("Sign should be either +1 or -1.\n");
+	else _error2_("Sign should be either +1 or -1.\n");
 
 	return;
Index: issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 12878)
@@ -67,9 +67,9 @@
 	for(j=0;j<M;j++){
 		double* matrix=array[j];
-		xfree((void**)&matrix);
+		xDelete<double>(matrix);
 	}
-	xfree((void**)&mdims_array);
-	xfree((void**)&ndims_array);
-	xfree((void**)&array);
+	xDelete<int>(mdims_array);
+	xDelete<int>(ndims_array);
+	xDelete<double*>(array);
 	
 	/*Assign output pointers: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.h	(revision 12878)
@@ -6,5 +6,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp	(revision 12878)
@@ -17,5 +17,5 @@
 
 	/*Display message*/
-	_printf_(VerboseModule(),"   Merging solution vector from fset to gset\n");
+	if(VerboseModule()) _pprintLine_("   Merging solution vector from fset to gset");
 
 	/*first, get gsize, fsize and ssize: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _MERGESOLUTIONFROMFTOGX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
